
#include "frazioni.h"

int MCD(int m, int n)
{
 int r;
 
 r = m % n; 
 if (r == 0) 
   return n;
 else  
     return MCD(n,r);
} 


struct FRAZIONE semplifica(struct FRAZIONE a)
{
 struct FRAZIONE f;
 int d;
 
 if (a.num > a.den)
   d = MCD(a.num, a.den);
 else
	 d = MCD(a.den, a.num);

 f.num = a.num/d;
 f.den = a.den/d;
 
 return f;
}

struct FRAZIONE somma(struct FRAZIONE a, struct FRAZIONE b)
{
 struct FRAZIONE c;

 c.den = a.den * b.den;
 c.num = a.num * b.den + b.num * a.den; 
 c = semplifica(c);
 
 return c;
}

struct FRAZIONE differenza (struct FRAZIONE a, struct FRAZIONE b)
{
 struct FRAZIONE c;

 c.den = a.den * b.den;
 c.num = a.num * b.den - b.num * a.den;
 c = semplifica(c);
 
 return c;
}

struct FRAZIONE prodotto(struct FRAZIONE a, struct FRAZIONE b)
{
 struct FRAZIONE c;

 c.num = a.num * b.num;
 c.den = a.den * b.den; 
 c = semplifica(c);
 
 return c;
}

struct FRAZIONE quoziente(struct FRAZIONE a, struct FRAZIONE b)
{
 struct FRAZIONE c;

 c.num = a.num * b.den;
 c.den = a.den * b.num; 
 c = semplifica(c);
 
 return c;
}
